import numpy as np
from scipy import interpolate
import pickle

clf = pickle.load(open('D:\\Git\\SensorPlayGround\\Assets\\StreamingAssets\\Studio\\Research\\dynamic_classifier_full_combined_linear.sav', 'rb'))
input_time = np.zeros(0)
sample_time = 100  # Data recorded with value 100.
sample_frequency = 60
number_of_angles = 19 # True value = 19
number_of_xyz = 171 # True value = 171
input()
i=0 #Enum - counts frames.
x= np.zeros(number_of_angles)
angle = np.zeros(number_of_angles)
xyz = np.zeros(number_of_xyz)

freq = np.linspace(0.0, sample_time/sample_frequency, sample_time)

#try:
while True:
    value = input()
    values = value.split(',')
    for n in range(number_of_xyz):
        xyz[n]= float(values[n])
    xyz = np.asarray(xyz)
    for k in range(number_of_angles):
        angle[k] = float(values[number_of_xyz+k])
    angle = np.asarray(angle)
    time = float(values[number_of_xyz+number_of_angles])
    if(i==0):
        time_0 = float(values[0])
    i +=1
    x = np.vstack([x,angle])
    time = time-time_0
    input_time = np.append(input_time,time)
    if(i<=sample_time):
        if(i==1):
            x = np.delete(x,0,0)
    else:
        x = np.delete(x,0,0)
        input_time = np.delete(input_time,0,0)
        x_fft = np.zeros(len(x))
        amplitude_list = np.zeros(3)
        for k in range(number_of_angles):
            #NaN fetching
            w = np.isnan(x[:,k].ravel())
            x[:,k].ravel()[w] =0
            #Stops here
            y_hat= interpolate.UnivariateSpline(input_time,x[:,k].ravel(),w=~w)             
            furrier_input = y_hat(input_time)
            furrier_input = furrier_input - np.mean(furrier_input)
            fft = np.abs(np.fft.fft(furrier_input, norm = 'ortho'))
            x_fft = np.vstack([x_fft,fft])
        x_fft = np.delete(x_fft,0,0)
        for k in range(number_of_angles):
            amplitude = np.flip(np.sort(x_fft[k,:]),axis=0)[0:6][::2]
            amplitude_list =  np.vstack([amplitude_list,amplitude])
        amplitude_list = np.delete(amplitude_list,0,0)
        amplitude_list = amplitude_list*0.8 # Try some numbers
        merged = np.append(xyz,np.asarray(amplitude_list).ravel())
        #NaN checking
        ww = np.isnan(merged)
        merged[ww] = 0
        #Nan checking done.
        for n in range(len(clf.classes_)):
            if(clf.predict_proba([merged.ravel()])[0][n]>0.75):
                print(clf.classes_[n])
    # print("So far, so good")


