# Loading required libraries
from keras.models import load_model
import numpy as np
# Loading the model object for classification
model = load_model("C:\\GIT\\UnitySensorPlayGround\\Assets\\StreamingAssets\\Studio\\Research\\model.h5")
labels = ['push_up', 'sitting', 'walking', 'squatting', 'waving']

data = np.zeros(190)
i = 0
input()
# Starting prediction
while True:
  # Getting in data one frame at a time and stacking them
  tmp = input()
  tmp = tmp.split(',')
  data = np.vstack([data, tmp])
  i += 1
  
  # The prediction will begin when we have reached 100 frames
  if (i >= 100):
    # Deleting first frame to keep data of dimension (100, 190)
    data = np.delete(data, 0, 0)
    
    # Doing prediction and printing label
    pred = int(model.predict_classes(x = np.reshape(data, newshape = (1, 100, 190))))
    print(labels[pred])